;------------------------------------------------------------------
;procedura gwna obliczajca spadki cinie elementw jednego typu
;ELEMENT (jednokierunkowy) W KTRYM dPa ZALENE od innego parametru ni kierunek

(defun obliczPa#w ( sciezkaPlik#w plik#w jm#w jm_wsp#w wszystkieKierPa#w listaDoPa#w / 
                    obi#w rozmiar#w kierunki#w rozmiar#w i#w j#w zwrot#w zwrotObi#w kiery#w
		    figura#w akcesoria#w parametr#w 
		    dane020#w dane025#w dane031#w dane040#w dane050#w) 

;jm#w       "_cm#w"
;jm_wsp#w   "0.1"
;zmienna przenoszca razem wykryte kierunki we wszystkich obiektach tego typu
;  wszystkieKierPa#w np.(("P1>P3" "P1>P2")("P1>P2" "P1>P3"))
;po rozpakowaniu listy listaDoPa#w tworzy z jej rekordu:
;  obi#w
;  rozmiar#w  ("d1mm" "150") ("d3mm" "400") ("Lmm" "140") ("Hmm" "87") ("kgTCPL" "0.5") 
;  kierunki#w (("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P3" "d3mm" "100.00" (151.929 73.3729 0.0)) 
;              ("P1" "d1mm" "200.00" (144.929 64.6729 0.0) "P2" "d1mm" "100.00" (158.929 64.6729 0.0)))
;  kiery#w    (("P3>P1" "P2>P1") ("P2>P1" "P3>P1")) - ju po podwojeniu-odwrceniu poniej
;  dalsze nie w kadym elemencie potrzebne:
;  figura#w   "12"
;  akcesoria#w (("" "")) lub (("WentyleSpiroRGS_akcesoria" "2")("WentyleSpiroRGS_lamelki" "1")
;                             ("WentyleSpiroRGS_przepustnica" "0"))


;rekonstrukcja wszystkieKierPa#w poniewa na wybr wykresu ma wpyw inna wielko 
;ni kierunki przepywu
(setq wszystkieKierPa#w '())
(foreach i#w listaDoPa#w (setq wszystkieKierPa#w 
                         (append wszystkieKierPa#w (list (cadar (cadr i#w))))))


;zaadowanie danych pod odpowiednie zmienne
(foreach i#w wszystkieKierPa#w
(cond

;020
((and (not dane020#w)(= i#w "020"))
     (progn (load (strcat sciezkaPlik#w plik#w "_020.lsp"))
            (setq dane020#w (obliczPa1#w)) ))
;025
((and (not dane025#w)(= i#w "025"))
     (progn (load (strcat sciezkaPlik#w plik#w "_025.lsp"))
            (setq dane025#w (obliczPa1#w)) ))
;031
((and (not dane031#w)(= i#w "031"))
     (progn (load (strcat sciezkaPlik#w plik#w "_031.lsp"))
            (setq dane031#w (obliczPa1#w)) ))
;040
((and (not dane040#w)(= i#w "040"))
     (progn (load (strcat sciezkaPlik#w plik#w "_040.lsp"))
            (setq dane040#w (obliczPa1#w)) ))
;050
((and (not dane040#w)(= i#w "050"))
     (progn (load (strcat sciezkaPlik#w plik#w "_050.lsp"))
            (setq dane050#w (obliczPa1#w)) ))

));cond/foreach


;obliczenie spadku cinienia na elemencie
(setq zwrot#w '())

(foreach i#w listaDoPa#w
(progn  (setq obi#w (handent (car i#w))
              kiery#w     (caddr i#w)
	      rozmiar#w   (cadr i#w) 
              parametr#w  (cadar rozmiar#w)
 	      kierunki#w  (cadddr i#w)
	      akcesoria#w (cadr (cddddr i#w)) )

;kiery#w - podwojone-odwrcone aby liczy dPa pod warunkiem innego
;te dla drugiego kierunku, trzeciego itd.
(setq p#w      kiery#w
      kiery#w (list kiery#w))
(repeat (- (length p#w) 1) 
        (setq kiery#w (append kiery#w (list
	              (append (list (car (reverse p#w))) (reverse (cdr (reverse p#w))))
))));list/append/setq/repeat


	(setq zwrotObi#w '())
	(foreach j#w kiery#w
	(progn

	(cond

	;020
	((and (or (equal j#w '("P1>P2" "P1>P3")) (equal j#w '("P2>P1" "P2>P3")) )
	      (= parametr#w "020") )
	      (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane020#w ) 
                             )))) )
	;025
	((and (or (equal j#w '("P1>P2" "P1>P3")) (equal j#w '("P2>P1" "P2>P3")) )
	      (= parametr#w "025") )
	      (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane025#w ) 
                             )))) )
	;031
	((and (or (equal j#w '("P1>P2" "P1>P3")) (equal j#w '("P2>P1" "P2>P3")) )
	      (= parametr#w "031") )
	      (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane031#w ) 
                             )))) )
	;040
	((and (or (equal j#w '("P1>P2" "P1>P3")) (equal j#w '("P2>P1" "P2>P3")) )
	      (= parametr#w "040") )
	      (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane040#w ) 
                             )))) )
	;050
	((and (or (equal j#w '("P1>P2" "P1>P3")) (equal j#w '("P2>P1" "P2>P3")) )
	      (= parametr#w "050") )
	      (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		             (liczyPa#w j#w rozmiar#w kierunki#w parametr#w 
                                        akcesoria#w dane050#w ) 
                             )))) )

	;inne kierunki  - tutaj obojtne
	( T                  (setq  zwrotObi#w (append zwrotObi#w (list (append (list j#w)
		             (list "" "0;PominSpadekC.") 
                             )))) )
	);cond
	));progn/foreach j#w

        (if zwrotObi#w (setq zwrotObi#w (append (list obi#w) zwrotObi#w)))

(if zwrotObi#w (setq zwrot#w (append zwrot#w (list zwrotObi#w))))
));progn/foreach i#w

;zwrot#w ((<Entity name: 2792a90> (("P1>P2") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")) 
;         (<Entity name: 2792cc8> (("P2>P1") "35" "0;Przekroczony zasig danych o 
;          spadkach!") (("P2>P1") "35" "0;Przekroczony zasig danych o spadkach!")))
zwrot#w
);defun











;podprocedura porednia obliczeniowa spadkw cinie jednego kierunku jednego elementu
(defun liczyPa#w ( i#w rozmiar#w kierunki#w parametr#w akcesoria#w dane#w /
		   nastawa#w nastawa1#w p#w d#w f#w text#w wyd#w zwrot#w kierTu#w )

;i#w ("P2>P1")
;rozmiar#w (("Rozmiar" "020") ("d1mm" "100") ("Lmm" "2000"))
;kierunki#w (("P1" "d1mm" "600.00" (-348.838 176.616 0.0) "P2" "d1mm" "600.00" (-348.838 179.356 0.0)))
;dane#w (("60" "10" "50")...)
;parametr#w "020"
;akcesoria#w (("WentyleFlaktbACT_Dysze" "1")...)


(if (not dane#w)
    (setq zwrot#w (list "" (strcat "0;Brak danych o spadkach cinie dla rozmiaru " parametr#w) ))

;else - jeli rozmiar uzbrojony w liczenie dPa
(progn

(setq nastawa#w (cadar akcesoria#w))	

		(cond ((member nastawa#w '("0"))  (setq nastawa1#w "360"))
		      ((member nastawa#w '("1"))  (setq nastawa1#w "300"))
		      ((member nastawa#w '("2"))  (setq nastawa1#w "240"))
		      ((member nastawa#w '("3"))  (setq nastawa1#w "180"))
		      ((member nastawa#w '("4"))  (setq nastawa1#w "120"))
		      ((member nastawa#w '("5"))  (setq nastawa1#w "60"))
		);cond

(setq kierTu#w (cadr kierunki#w))

               ;wymiar>przekrj
		(setq p#w  (nth 1 kierTu#w)
                      d#w  p#w)
		(setq d#w  (/ (atof (cadr (assoc d#w rozmiar#w))) 1000.0) ;[m]
		      f#w  (/ (* pi (* d#w d#w)) 4))  ;[m2]
		(setq text#w (strcat "0;NawiewnikACTIVENT," ))



(setq wyd#w (abs (- (atof (nth 2 kierTu#w)) (atof (nth 6 kierTu#w)) ))) ;[m3/h]
(setq wyd#w (/ wyd#w 3.6)) ;[l/s]

;dzielimy wydajno przez liczb metrw, bo taka jest jednostka osi X
(setq p#w   (/ (atof (cadr (assoc "Lmm" rozmiar#w))) 1000.0) ;[m]
      wyd#w (/ wyd#w p#w))


;wywoanie odczytu dPa z tablicy/wykresu
;(Nastawa, Wyd[l/s], DPa[Pa])
(setq zwrot#w (LiczyPa_odczytDPa#w nastawa1#w (rtos wyd#w 2 12) dane#w))

(if (and text#w (= (cadr zwrot#w) "")) (setq zwrot#w (list (car zwrot#w) text#w)))

));progn-else/if parametr#w

zwrot#w   ;'("35" "Trjn.przelot") lub np. '("" "0;Przekroczony zakres na wykresie spadkw ci.") 
);defun 






